{% extends 'base.html' %}
{% load custom_tags %}
{% block nav-proyecto %}
    <li class="nav-item active">
        <a class="nav-link" href="{% url 'Proyecto:index' %}">Proyecto <span class="sr-only">(current)</span></a>
    </li>
{% endblock %}

{% block content %}
    <style>
        /* Absolute Center Spinner */
        .loading {
            position: fixed;
            z-index: 999;
            overflow: show;
            margin: auto;
            top: 0;
            left: 0;
            bottom: 0;
            right: 0;
            width: 50px;
            height: 50px;
        }

        /* Transparent Overlay */
        .loading:before {
            content: '';
            display: block;
            position: fixed;
            top: 0;
            left: 0;
            width: 100%;
            height: 100%;
            background-color: rgba(255, 255, 255, 0.5);
        }

        /* :not(:required) hides these rules from IE9 and below */
        .loading:not(:required) {
            /* hide "loading..." text */
            font: 0/0 a;
            color: transparent;
            text-shadow: none;
            background-color: transparent;
            border: 0;
        }

        .loading:not(:required):after {
            content: '';
            display: block;
            font-size: 10px;
            width: 50px;
            height: 50px;
            margin-top: -0.5em;

            border: 15px solid rgba(33, 150, 243, 1.0);
            border-radius: 100%;
            border-bottom-color: transparent;
            -webkit-animation: spinner 1s linear 0s infinite;
            animation: spinner 1s linear 0s infinite;


        }

        /* Animation */

        @-webkit-keyframes spinner {
            0% {
                -webkit-transform: rotate(0deg);
                -moz-transform: rotate(0deg);
                -ms-transform: rotate(0deg);
                -o-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                -moz-transform: rotate(360deg);
                -ms-transform: rotate(360deg);
                -o-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }

        @-moz-keyframes spinner {
            0% {
                -webkit-transform: rotate(0deg);
                -moz-transform: rotate(0deg);
                -ms-transform: rotate(0deg);
                -o-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                -moz-transform: rotate(360deg);
                -ms-transform: rotate(360deg);
                -o-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }

        @-o-keyframes spinner {
            0% {
                -webkit-transform: rotate(0deg);
                -moz-transform: rotate(0deg);
                -ms-transform: rotate(0deg);
                -o-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                -moz-transform: rotate(360deg);
                -ms-transform: rotate(360deg);
                -o-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }

        @keyframes spinner {
            0% {
                -webkit-transform: rotate(0deg);
                -moz-transform: rotate(0deg);
                -ms-transform: rotate(0deg);
                -o-transform: rotate(0deg);
                transform: rotate(0deg);
            }
            100% {
                -webkit-transform: rotate(360deg);
                -moz-transform: rotate(360deg);
                -ms-transform: rotate(360deg);
                -o-transform: rotate(360deg);
                transform: rotate(360deg);
            }
        }
    </style>
    <div style="margin: 3%;">

        <div class="h3 mt-3 text-center ">
            <h1 class="text-light">Burndown Chart</h1>
            <h1 class="text-light">{{ proyecto.nombre }} - Sprint {{ idSprint }}</h1>
        </div>
        <a id="downloadPdf" class="btn btn-light m-1 btn-outline-dark">Generar Reporte</a>
        <a class="btn btn-light btn-outline-dark" href="{% url 'Proyecto:ListarSprint' proyecto.id %}">Volver</a>


        <div class="bg-light border rounded border-dark p-3" id="reportPage">

            <h5>Usuario actual: {{ user.first_name }} {{ user.last_name }}</h5>
            <h5>Fecha: <div id="date"></div></h5>
            <br>
            <div class="loading" id="spinner" role="status">
                <span class="sr-only">Loading...</span>
            </div>
            <canvas id="myChart"></canvas>
        </div>

    </div>

    <script>
        da = new Date();
        document.getElementById("date").innerHTML = da.toUTCString();
        $.getJSON('http://127.0.0.1:8000/proyectos/burndownchartjson/{{ idSprint }}', function (data) {
            const ctx = document.getElementById('myChart').getContext('2d');
            const myChart = new Chart(ctx, {
                type: 'line',
                data: {
                    labels: data.labelsDias,
                    datasets: [{
                        label: 'Horas de trabajo restante',
                        data: data.horasRestanteTrabajo,
                        backgroundColor: [
                            'rgba(54, 162, 235, 0.5)'
                        ],
                        borderColor: [
                            'rgb(54, 162, 235, 1)'
                        ],
                        borderWidth: 3,
                        yAxisID: 'y'
                    }, {
                        label: 'Us Aprobadas',
                        data: data.nroDeTareasTerminadas,
                        backgroundColor: [
                            'rgba(255, 205, 86, 0.5)'
                        ],
                        borderColor: [
                            'rgba(255, 205, 86, 1)'
                        ],
                        borderWidth: 3,
                        type: 'bar',
                        yAxisID: 'y1'
                    }, {
                        label: 'Linea Real',
                        data: data.lineaIdeal,
                        backgroundColor: [
                            'rgba(75, 192, 192, 0.5)'
                        ],
                        borderColor: [
                            'rgba(75, 192, 192, 1)'
                        ],
                        borderWidth: 3,
                        yAxisID: 'y'
                    }]
                },
                options: {
                    scales: {
                        x: {
                            title: {
                                display: true,
                                text: 'Dias'
                            }
                        },
                        y: {
                            title: {
                                display: true,
                                text: 'Horas'
                            },
                            beginAtZero: true
                        },
                        y1: {
                            title: {
                                display: true,
                                text: 'Cantidad de US'
                            },
                            type: 'linear',
                            display: true,
                            position: 'right',
                            max: data.cantidadPP * 2,
                            // grid line settings
                            grid: {
                                drawOnChartArea: false, // only want the grid lines for one axis to show up
                            },
                        }
                    }
                }
            });
            hideSpinner();
        });

        $('#downloadPdf').click(function (event) {
            // get size of report page
            var reportPageHeight = $('#reportPage').innerHeight();
            var reportPageWidth = $('#reportPage').innerWidth();

            // create a new canvas object that we will populate with all other canvas objects
            var pdfCanvas = $('<canvas />').attr({
                id: "canvaspdf",
                width: reportPageWidth,
                height: reportPageHeight
            });

            // keep track canvas position
            var pdfctx = $(pdfCanvas)[0].getContext('2d');
            var pdfctxX = 0;
            var pdfctxY = 0;
            var buffer = 100;

            // for each chart.js chart
            $("canvas").each(function (index) {
                // get the chart height/width
                var canvasHeight = $(this).innerHeight();
                var canvasWidth = $(this).innerWidth();

                // draw the chart into the new canvas
                pdfctx.drawImage($(this)[0], pdfctxX, pdfctxY, canvasWidth, canvasHeight);
                pdfctxX += canvasWidth + buffer;

                // our report page is in a grid pattern so replicate that in the new canvas
                if (index % 2 === 1) {
                    pdfctxX = 0;
                    pdfctxY += canvasHeight + buffer;
                }
            });

            // create new pdf and add our new canvas as an image
            var pdf = new jsPDF('l', 'pt', [reportPageWidth, reportPageHeight]);
            var mediox = reportPageWidth / 2;
            pdf.setFontSize(35);
            pdf.myText("Burndown Chart", {align: "center"}, 0, 50);
            //pdf.text(mediox - 20, 40, 'Burndown Chart');
            pdf.setFontSize(25);
            d = new Date();
            pdf.myText('{{ proyecto.nombre }}' + ' - Sprint ' +{{ idSprint }}, {align: "center"}, 0, 90);
            pdf.setFontSize(18);
            pdf.setFont(undefined, 'bold');
            pdf.text(80, 125, 'Fecha de Emision: ');
            pdf.setFontSize(16);
            pdf.setFont(undefined, 'normal');
            pdf.text(250, 125, d.toUTCString());
            pdf.setFontSize(18);
            pdf.setFont(undefined, 'bold');
            pdf.text(reportPageWidth - 360, 125, 'Usuario: ');
            pdf.setFontSize(16);
            pdf.setFont(undefined, 'normal');
            pdf.text(reportPageWidth - 275, 125, '{{ user.first_name }} {{ user.last_name }} ');
            pdf.addImage($(pdfCanvas)[0], 'PNG', 180, 150);

            // download the pdf
            pdf.save('BurnDownChart.pdf');
        });

        (function (API) {
            API.myText = function (txt, options, x, y) {
                options = options || {};
                /* Use the options align property to specify desired text alignment
                 * Param x will be ignored if desired text alignment is 'center'.
                 * Usage of options can easily extend the function to apply different text
                 * styles and sizes
                */
                if (options.align == "center") {
                    // Get current font size
                    var fontSize = this.internal.getFontSize();

                    // Get page width
                    var pageWidth = this.internal.pageSize.width;

                    // Get the actual text's width
                    /* You multiply the unit width of your string by your font size and divide
                     * by the internal scale factor. The division is necessary
                     * for the case where you use units other than 'pt' in the constructor
                     * of jsPDF.
                    */
                    txtWidth = this.getStringUnitWidth(txt) * fontSize / this.internal.scaleFactor;

                    // Calculate text's x coordinate
                    x = (pageWidth - txtWidth) / 2;
                }

                // Draw text at x,y
                this.text(txt, x, y);
            }
        })(jsPDF.API);

        // Funcion para ocultar el Sprinner
        function hideSpinner() {
            document.getElementById('spinner')
                .style.display = 'none';
        }

    </script>

{% endblock %}
